{-# LANGUAGE MagicHash #-}
{-# LANGUAGE ScopedTypeVariables #-}
{-# OPTIONS_GHC -fno-warn-overlapping-patterns #-}

module Curry_Either
  ( d_C_lefts
  , d_C_rights
  , d_C_isLeft
  , d_C_isRight
  , d_C_fromLeft
  , d_C_fromRight
  , d_C_partitionEithers )
  where

import Basics
import qualified Curry_Prelude


d_C_lefts :: forall t1 t0 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry
  t0) => Curry_Prelude.OP_List (Curry_Prelude.C_Either t0 t1) -> Cover
  -> ConstStore -> Curry_Prelude.OP_List t0
d_C_lefts x1 cd cs = Curry_Prelude.d_C_foldr (acceptCs id
  d_OP_lefts_dot_uscore_hash_lambda3) Curry_Prelude.OP_List x1 cd cs

d_OP_lefts_dot_uscore_hash_lambda3 :: forall t1 t0 . (Curry_Prelude.Curry t1
  , Curry_Prelude.Curry t0) => Curry_Prelude.C_Either t0 t1
  -> Curry_Prelude.OP_List t0 -> Cover -> ConstStore -> Curry_Prelude.OP_List t0
d_OP_lefts_dot_uscore_hash_lambda3 x1 x2 cd cs = case x1 of
  Curry_Prelude.C_Left x3 -> Curry_Prelude.OP_Cons x3 x2
  Curry_Prelude.C_Right x4 -> x2
  Curry_Prelude.Choice_C_Either d i l r -> narrow d i
    (d_OP_lefts_dot_uscore_hash_lambda3 l x2 cd cs)
    (d_OP_lefts_dot_uscore_hash_lambda3 r x2 cd cs)
  Curry_Prelude.Choices_C_Either d i xs -> narrows cs d i (\z ->
    d_OP_lefts_dot_uscore_hash_lambda3 z x2 cd cs) xs
  Curry_Prelude.Guard_C_Either d c e -> guardCons d c
    (d_OP_lefts_dot_uscore_hash_lambda3 e x2 cd $! addCs c cs)
  Curry_Prelude.Fail_C_Either d info -> failCons d (traceFail
    "Either.lefts._#lambda3" [show x1, show x2] info)
  _ -> failCons cd (consFail "Either.lefts._#lambda3" (showCons x1))

d_C_rights :: forall t0 t1 . (Curry_Prelude.Curry t0, Curry_Prelude.Curry
  t1) => Curry_Prelude.OP_List (Curry_Prelude.C_Either t0 t1) -> Cover
  -> ConstStore -> Curry_Prelude.OP_List t1
d_C_rights x1 cd cs = Curry_Prelude.d_C_foldr (acceptCs id
  d_OP_rights_dot_uscore_hash_lambda7) Curry_Prelude.OP_List x1 cd cs

d_OP_rights_dot_uscore_hash_lambda7 :: forall t0 t1 . (Curry_Prelude.Curry t0
  , Curry_Prelude.Curry t1) => Curry_Prelude.C_Either t0 t1
  -> Curry_Prelude.OP_List t1 -> Cover -> ConstStore -> Curry_Prelude.OP_List t1
d_OP_rights_dot_uscore_hash_lambda7 x1 x2 cd cs = case x1 of
  Curry_Prelude.C_Right x3 -> Curry_Prelude.OP_Cons x3 x2
  Curry_Prelude.C_Left x4 -> x2
  Curry_Prelude.Choice_C_Either d i l r -> narrow d i
    (d_OP_rights_dot_uscore_hash_lambda7 l x2 cd cs)
    (d_OP_rights_dot_uscore_hash_lambda7 r x2 cd cs)
  Curry_Prelude.Choices_C_Either d i xs -> narrows cs d i (\z ->
    d_OP_rights_dot_uscore_hash_lambda7 z x2 cd cs) xs
  Curry_Prelude.Guard_C_Either d c e -> guardCons d c
    (d_OP_rights_dot_uscore_hash_lambda7 e x2 cd $! addCs c cs)
  Curry_Prelude.Fail_C_Either d info -> failCons d (traceFail
    "Either.rights._#lambda7" [show x1, show x2] info)
  _ -> failCons cd (consFail "Either.rights._#lambda7" (showCons x1))

d_C_isLeft :: forall t0 t1 . (Curry_Prelude.Curry t0, Curry_Prelude.Curry
  t1) => Curry_Prelude.C_Either t0 t1 -> Cover -> ConstStore
  -> Curry_Prelude.C_Bool
d_C_isLeft x1 cd cs = case x1 of
  Curry_Prelude.C_Left x2 -> Curry_Prelude.C_True
  Curry_Prelude.C_Right x3 -> Curry_Prelude.C_False
  Curry_Prelude.Choice_C_Either d i l r -> narrow d i (d_C_isLeft l cd cs)
    (d_C_isLeft r cd cs)
  Curry_Prelude.Choices_C_Either d i xs -> narrows cs d i (\z -> d_C_isLeft z cd
    cs) xs
  Curry_Prelude.Guard_C_Either d c e -> guardCons d c (d_C_isLeft e cd $! addCs
    c cs)
  Curry_Prelude.Fail_C_Either d info -> failCons d (traceFail "Either.isLeft"
    [show x1] info)
  _ -> failCons cd (consFail "Either.isLeft" (showCons x1))

d_C_isRight :: forall t0 t1 . (Curry_Prelude.Curry t0, Curry_Prelude.Curry
  t1) => Curry_Prelude.C_Either t0 t1 -> Cover -> ConstStore
  -> Curry_Prelude.C_Bool
d_C_isRight x1 cd cs = case x1 of
  Curry_Prelude.C_Left x2 -> Curry_Prelude.C_False
  Curry_Prelude.C_Right x3 -> Curry_Prelude.C_True
  Curry_Prelude.Choice_C_Either d i l r -> narrow d i (d_C_isRight l cd cs)
    (d_C_isRight r cd cs)
  Curry_Prelude.Choices_C_Either d i xs -> narrows cs d i (\z -> d_C_isRight z
    cd cs) xs
  Curry_Prelude.Guard_C_Either d c e -> guardCons d c (d_C_isRight e cd $! addCs
    c cs)
  Curry_Prelude.Fail_C_Either d info -> failCons d (traceFail "Either.isRight"
    [show x1] info)
  _ -> failCons cd (consFail "Either.isRight" (showCons x1))

d_C_fromLeft :: forall t1 t0 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry
  t0) => Curry_Prelude.C_Either t0 t1 -> Cover -> ConstStore -> t0
d_C_fromLeft x1 cd cs = case x1 of
  Curry_Prelude.C_Left x2 -> x2
  Curry_Prelude.Choice_C_Either d i l r -> narrow d i (d_C_fromLeft l cd cs)
    (d_C_fromLeft r cd cs)
  Curry_Prelude.Choices_C_Either d i xs -> narrows cs d i (\z -> d_C_fromLeft z
    cd cs) xs
  Curry_Prelude.Guard_C_Either d c e -> guardCons d c (d_C_fromLeft e cd $!
    addCs c cs)
  Curry_Prelude.Fail_C_Either d info -> failCons d (traceFail "Either.fromLeft"
    [show x1] info)
  _ -> failCons cd (consFail "Either.fromLeft" (showCons x1))

d_C_fromRight :: forall t0 t1 . (Curry_Prelude.Curry t0, Curry_Prelude.Curry
  t1) => Curry_Prelude.C_Either t0 t1 -> Cover -> ConstStore -> t1
d_C_fromRight x1 cd cs = case x1 of
  Curry_Prelude.C_Right x2 -> x2
  Curry_Prelude.Choice_C_Either d i l r -> narrow d i (d_C_fromRight l cd cs)
    (d_C_fromRight r cd cs)
  Curry_Prelude.Choices_C_Either d i xs -> narrows cs d i (\z -> d_C_fromRight z
    cd cs) xs
  Curry_Prelude.Guard_C_Either d c e -> guardCons d c (d_C_fromRight e cd $!
    addCs c cs)
  Curry_Prelude.Fail_C_Either d info -> failCons d (traceFail "Either.fromRight"
    [show x1] info)
  _ -> failCons cd (consFail "Either.fromRight" (showCons x1))

d_C_partitionEithers :: forall t0 t1 . (Curry_Prelude.Curry t0
  , Curry_Prelude.Curry t1) => Cover -> ConstStore -> Curry_Prelude.OP_List
  (Curry_Prelude.C_Either t0 t1) -> Cover -> ConstStore
  -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List t0) (Curry_Prelude.OP_List
  t1)
d_C_partitionEithers cd cs = Curry_Prelude.d_C_foldr (Curry_Prelude.d_C_either
  (acceptCs id d_OP_partitionEithers_dot_left_dot_24) (acceptCs id
  d_OP_partitionEithers_dot_right_dot_24)) (Curry_Prelude.OP_Tuple2
  Curry_Prelude.OP_List Curry_Prelude.OP_List)

d_OP_partitionEithers_dot_left_dot_24 :: forall t0 t1 . (Curry_Prelude.Curry t0
  , Curry_Prelude.Curry t1) => t0 -> Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List t0) t1 -> Cover -> ConstStore
  -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List t0) t1
d_OP_partitionEithers_dot_left_dot_24 x1 x2 cd cs = case x2 of
  Curry_Prelude.OP_Tuple2 x3 x4 -> Curry_Prelude.OP_Tuple2
    (Curry_Prelude.OP_Cons x1 x3) x4
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i
    (d_OP_partitionEithers_dot_left_dot_24 x1 l cd cs)
    (d_OP_partitionEithers_dot_left_dot_24 x1 r cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z ->
    d_OP_partitionEithers_dot_left_dot_24 x1 z cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c
    (d_OP_partitionEithers_dot_left_dot_24 x1 e cd $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "Either.partitionEithers.left.24" [show x1, show x2] info)
  _ -> failCons cd (consFail "Either.partitionEithers.left.24" (showCons x2))

d_OP_partitionEithers_dot_right_dot_24 :: forall t1 t0 . (Curry_Prelude.Curry t1
  , Curry_Prelude.Curry t0) => t0 -> Curry_Prelude.OP_Tuple2 t1
  (Curry_Prelude.OP_List t0) -> Cover -> ConstStore -> Curry_Prelude.OP_Tuple2
  t1 (Curry_Prelude.OP_List t0)
d_OP_partitionEithers_dot_right_dot_24 x1 x2 cd cs = case x2 of
  Curry_Prelude.OP_Tuple2 x3 x4 -> Curry_Prelude.OP_Tuple2 x3
    (Curry_Prelude.OP_Cons x1 x4)
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i
    (d_OP_partitionEithers_dot_right_dot_24 x1 l cd cs)
    (d_OP_partitionEithers_dot_right_dot_24 x1 r cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z ->
    d_OP_partitionEithers_dot_right_dot_24 x1 z cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c
    (d_OP_partitionEithers_dot_right_dot_24 x1 e cd $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "Either.partitionEithers.right.24" [show x1, show x2] info)
  _ -> failCons cd (consFail "Either.partitionEithers.right.24" (showCons x2))

